package uk.ac.leeds.ccg.andyt.projects.genesis.society.persons;

import java.util.Calendar;
//import java.util.HashSet;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.demography.Fertility;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.environment.Environment;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.organisations.Family;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.organisations.Household;
import uk.ac.leeds.ccg.andyt.projects.genesis.utilities.Time;

public class Female extends Person {

    public static final int _NormalGestationPeriod = 266;
    public int _LengthOfFertilityPeriod;
    public int _StartOfFertiliyPeriod;
    
    
    // Gestation period in humans taken as 266 days
    // http://en.wikipedia.org/wiki/Gestation_period
    public Time _Time_DueToGiveBirth; // If _Time_DueToGiveBirth != null then female is pregnant
    
    public Female() {
    }

//    public Female(
//            Environment _Environment,
//            Object _ID,
//            Calendar _Calendar_Birth) {
//        this._Environment = _Environment;
//        this._ID = _ID;
//        this._Calendar_Birth = _Calendar_Birth;
//        this._Family = new Family(this);
//        this._Household = new Household();
//        this._Household._Add_Person(this);
//        _Init_Fertility();
//    }

    public Female(
            Environment _Environment,
            Object _ID,
            Time _Time_Birth) {
        this._Environment = _Environment;
        this._ID = _ID;
        this._Time_Birth = new Time(_Time_Birth);
        this._Family = new Family(this);
        this._Household = new Household();
        this._Household._Add_Person(this);
    }

//    public Female(
//            Environment _Environment,
//            Object _ID,
//            Calendar _Calendar_Birth,
//            Household _Household) {
//        this._Environment = _Environment;
//        this._ID = _ID;
//        this._Calendar_Birth = _Calendar_Birth;
//        this._Family = new Family(this);
//        this._Household = _Household;
//        this._Household._Add_Person(this);
//    }

    public Female(
            Environment _Environment,
            Object _ID,
            Time _Time_Birth,
            Household _Household) {
        this._Environment = _Environment;
        this._ID = _ID;
        this._Time_Birth = new Time(_Time_Birth);
        this._Family = new Family(this);
        this._Household = _Household;
        this._Household._Add_Person(this);
    }

        public Female(
            Environment _Environment,
            Object _ID,
            Time _Time_Birth,
            Household _Household,
            Object _Location) {
        this._Environment = _Environment;
        this._ID = _ID;
        this._Time_Birth = new Time(_Time_Birth);
        this._Family = new Family(this);
        this._Household = _Household;
        this._Household._Add_Person(this);
        this._Location = _Location;
    }

    public Female(
            Environment _Environment,
            Object _ID,
            Time _Time_Birth,
            Object _Place_Location,
            Household _Household) {
        this._Environment = _Environment;
        this._ID = _ID;
        this._Time_Birth = new Time(_Time_Birth);
        this._Family = new Family(this);
        this._Household = _Household;
        this._Household._Add_Person(this);
    }
            
    public int get_Gender() {
        return 0;
    }
    
    public void _Init_Fertility(){
        this._LengthOfFertilityPeriod = 2 + this._Environment._Random.nextInt(5);
        this._StartOfFertiliyPeriod = this._Environment._Random.nextInt(28 - _LengthOfFertilityPeriod);
        //this._FertileDays_HashSet.add(_startOfFertiliyPeriod);
    }
    
    public double get_Fertility(Fertility _Fertility){
        //double _GeneralFertilityForAge = _Fertility.get_Fertility_Female(get_AgeInYears_int(_Calendar_Birth));
        double _GeneralFertilityForAge = _Fertility.get_Fertility_Female(get_AgeInYears_int(_Time_Birth));
        if (this._IsPregnant()){
            return 0.0d;
        } else {
//            HashSet _Children = this._Family.get_Children();
//            int _Day = _Environment._Day;
//            if (_Children == null){
//                return _GeneralFertilityForAge * ;
//            }
        }
        return _GeneralFertilityForAge;
    }
    
    /**
     * This sets the due date assuming 266 day gestation
     */
    public void set_Pregnant(){
        Time _DueDate = new Time(_Environment._Time);
        for ( int i = 0; i < _NormalGestationPeriod; i ++ ){
            _DueDate._Increment_Day();
        }
        this._Time_DueToGiveBirth = _DueDate;
    }
    
    public boolean _IsPregnant(){
        return _Time_DueToGiveBirth!=null;
    }
    
    /**
     *  This resets _DueDate creates and returns a new Male or Female Person.
     */
    public Person _Gives_Birth(){
        Person result;
        _Time_DueToGiveBirth = null;
        Object _ID = new Object();
        // Equal probabilty of male and female to start
        if (_Environment._Random.nextBoolean()){
            result = new Male(
                    _Environment,
                    _ID,
                    _Environment._Time,
                    _Household,
                    _Location);
        } else {
            result = new Female(
                    _Environment,
                    _ID, 
                    _Environment._Time,
                    _Household,
                    _Location);
        }
        // @TODO Add to household and set family relationships up...
        _Household._Add_Person(result);
        return result;
    }
}
