/**
 * A component of a library for 
 * <a href="http://www.geog.leeds.ac.uk/people/a.turner/src/andyt/java/projects/GENESIS/">GENESIS</a>
 * Copyright (C) 2008
 * <a href="http://www.geog.leeds.ac.uk/people/a.turner/">Andy Turner</a>,
 * <a href="http://www.leeds.ac.uk/">University of Leeds</a>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
package uk.ac.leeds.ccg.andyt.projects.genesis.society.persons;

import uk.ac.leeds.ccg.andyt.projects.genesis.society.environment.Environment;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.organisations.Family;
//import uk.ac.leeds.ccg.andyt.projects.genesis.society.*;
import uk.ac.leeds.ccg.andyt.projects.genesis.society.organisations.Household;
import java.util.Calendar;
//import java.util.Date;
import uk.ac.leeds.ccg.andyt.projects.genesis.utilities.Time;

/**
 * This is a class for an individual human.
 */
public abstract class Person {

    public Environment _Environment;
    public Object _ID;
    public Calendar _Calendar_Birth;
    public Time _Time_Birth;
    //public Calendar _Calendar_Death;
    public Time _Time_Death;
    public Object _Location_Birth;
    public Object _Location_Death;
    public Object _Location;
    public Family _Family;
    public Household _Household;
    public Object _HouseholdHistory;
    public double _Fertility;
    public double _MortalityProbability;
    
    double _Resource;

//    public void set_DateOfDeath_Calendar(Calendar _TimeOfDeath_Calendar) {
//        this._TimeOfDeath_Calendar = _TimeOfDeath_Calendar;
//    }

    public void set_Time_Death(Time _Time_Death) {
        this._Time_Death = new Time(_Time_Death);
    }

    /**
     * Prints Persons Age at Current Computer Date using default Calendar
     */
    public void print_Age() {
        print_Age(Calendar.getInstance());
        //print_Age(_Environment._Calendar);
    }

    /**
     * Prints Persons Age at Date given by _Calendar
     */
    public void print_Age(Calendar _Calendar) {
        //Date _TimeOfBirth_Date = _TimeOfBirth_Calendar.getTime();
        //Date _Time = _Time_Calendar.getTime();
        //System.out.println("_Date " + _Time + " _TimeOfBirth_Date " + _TimeOfBirth_Date);
        int _DAY_OF_YEAR = _Calendar.get(Calendar.DAY_OF_YEAR);
        int _Calendar_Birth_DAY_OF_YEAR = _Calendar_Birth.get(Calendar.DAY_OF_YEAR);
        int _Age_Day;
        int _Age_Year = _Calendar.get(Calendar.YEAR) - _Calendar_Birth.get(Calendar.YEAR);
        if (_DAY_OF_YEAR < _Calendar_Birth_DAY_OF_YEAR) {
            _Age_Year--;
            //_Age_Day = _Calendar.getMaximum(Calendar.YEAR) - (_DateOfBirth_DAY_OF_YEAR - _DAY_OF_YEAR);
            _Age_Day = 365 - (_Calendar_Birth_DAY_OF_YEAR - _DAY_OF_YEAR);
        } else {
            _Age_Day = _DAY_OF_YEAR - _Calendar_Birth_DAY_OF_YEAR;
        }
        System.out.println("_Age_Year " + _Age_Year + " _Age_Day " + _Age_Day);
    }

    public int get_AgeInYears_int(
            Calendar _Calendar) {
        int _Age_Year;
        int _DAY_OF_YEAR = _Calendar.get(Calendar.DAY_OF_YEAR);
        if (_Calendar_Birth == null) {
            _Age_Year = _Calendar.get(Calendar.YEAR) - _Time_Birth._Year;

        } else {
            //Date _TimeOfBirth_Date = _TimeOfBirth_Calendar.getTime();
            //Date _Time = _Time_Calendar.getTime();
            //System.out.println("_Date " + _Time + " _TimeOfBirth_Date " + _TimeOfBirth_Date);
            int _Time_Birth_DAY_OF_YEAR = _Calendar_Birth.get(Calendar.DAY_OF_YEAR);
            _Age_Year = _Calendar.get(Calendar.YEAR) - _Calendar_Birth.get(Calendar.YEAR);
            int _Age_Day;
            if (_DAY_OF_YEAR < _Time_Birth_DAY_OF_YEAR) {
                _Age_Year--;
                //_Age_Day = _Time_Calendar.getMaximum(Calendar.YEAR) - (_DateOfBirth_DAY_OF_YEAR - _DAY_OF_YEAR);
                _Age_Day = 365 - (_Time_Birth_DAY_OF_YEAR - _DAY_OF_YEAR);
            } else {
                _Age_Day = _DAY_OF_YEAR - _Time_Birth_DAY_OF_YEAR;
            }
            System.out.println("_Age_Year " + _Age_Year);
        }
        return _Age_Year;
    }

    public int get_AgeInYears_int(
            Time _Time) {
        double _Age_double = get_Age_double(_Time);
        return (int)_Age_double;
    }
    
    public int get_AgeInYears_int() {
        //return get_AgeInYears_int(_Environment._Calendar);
        return get_AgeInYears_int(_Environment._Time);
    }
    
    /**
     * Returns the Persons Age as a double
     */
    public double get_Age_double(Calendar _Calendar) {
        double result;
        int _DAY_OF_YEAR = _Calendar.get(Calendar.DAY_OF_YEAR);
        int _Calendar_Birth_DAY_OF_YEAR = _Calendar_Birth.get(Calendar.DAY_OF_YEAR);
        result = _Calendar.get(Calendar.YEAR) - _Calendar_Birth.get(Calendar.YEAR);
        double _DaysInYear = (double) Time._Normal_Days_In_Year;
        if (_DAY_OF_YEAR < _Calendar_Birth_DAY_OF_YEAR) {
            result -= 1.0d;
            result += (_DaysInYear - (_Calendar_Birth_DAY_OF_YEAR - _DAY_OF_YEAR)) / _DaysInYear;
        } else {
            result += (_DAY_OF_YEAR - _Calendar_Birth_DAY_OF_YEAR) / _DaysInYear;
        }
        //System.out.println("_Age " + _Age);
        return result;
    }
    
    /**
     * Returns the Persons Age as a double
     */
    public double get_Age_double(Time _Time) {
        double result;
        int _DayOfYear = _Time._DayOfYear;
        int _Time_Birth_DayOfYear = _Time_Birth._DayOfYear;
        result = _Time._Year - _Time_Birth._Year;
        double _DaysInYear = (double) Time._Normal_Days_In_Year;
        if (_DayOfYear < _Time_Birth_DayOfYear) {
            result -= 1.0d;
            result += (_DaysInYear - (_Time_Birth_DayOfYear - _DayOfYear)) / _DaysInYear;
        } else {
            result += (_DayOfYear - _Time_Birth_DayOfYear) / _DaysInYear;
        }
        //System.out.println("_Age " + _Age);
        return result;
    }

    /**
     * Returns the Persons Age as a double
     */
    public double get_Age_double() {
        //return get_Age_double(_Environment._Calendar);
        return get_Age_double(_Environment._Time);
    }

    public abstract int get_Gender();
    
    /**
     * @return description of this.
     */
    @Override
    public String toString() {
        String _String = new String("Person: ");
        //_String += "Age " + get_AgeInYears_int(_Environment._Calendar);
        _String += "Age " + get_AgeInYears_int(_Environment._Time);
        //_String += "Age " + get_Age_double();
        if (_Calendar_Birth == null) {
            _String += ", DoB " + _Time_Birth.toString();
        } else {
            _String += ", DoB " + _Calendar_Birth.getTime();
        }
//        if (_Calendar_Death != null) {
//            _String += ", DoD " + _Calendar_Death.getTime();
//        }
        if (_Time_Death != null) {
            _String += ", DoD " + _Time_Death;
        }
        _String += "; " + _Family.toString();
        _String += "; " + _Household.toString();
        return _String;
    }
}
